Package: pQTLdata
Title: A Collection of Proteome Panels and Metadata
Version: 0.6
Date: 2026-3-9
Authors@R: c(
    person("Jing Hua", "Zhao", , "jinghuazhao@hotmail.com", role = c("aut", "cre"),
           comment = c(ORCID = "0000-0002-1463-5870", "0000-0003-4930-3582")),
    person("Uwe", "Ligges", role = "ctb"),
    person("Benjamin", "Altmann", role = "ctb"),
    person("Brian", "Ripley", role = "ctb")
    )
Description: It aggregates protein panel data and metadata for protein quantitative
 trait locus (pQTL) analysis using 'pQTLtools' (<https://jinghuazhao.github.io/pQTLtools/>).
 The package includes data from affinity-based panels such as 'Olink' (<https://olink.com/>) 
 and 'SomaScan' (<https://somalogic.com/>), as well as mass spectrometry-based panels from
 'CellCarta' (<https://cellcarta.com/>), 'Seer' (<https://seer.bio/>) and 'SWATH-MS'
 (<doi:10.15252/msb.20178126>). The metadata encompasses updated annotations
 and publication details.
License: MIT + file LICENSE
URL: https://jinghuazhao.github.io/pQTLdata/,
        https://github.com/jinghuazhao/pQTLdata
BugReports: https://github.com/jinghuazhao/pQTLdata/issues
Depends: R (>= 3.5.0)
Imports: knitr, Rdpack
RdMacros: Rdpack
Suggests: dplyr, grid, EnsDb.Hsapiens.v75, ensembldb, IRanges,
        org.Hs.eg.db, S4Vectors, VennDiagram
VignetteBuilder: knitr
LazyData: Yes
LazyLoad: Yes
LazyDataCompression: xz
NeedsCompilation: no
Encoding: UTF-8
RoxygenNote: 7.3.3
Packaged: 2026-03-09 11:38:17 UTC; jhz22
Author: Jing Hua Zhao [aut, cre] (ORCID:
    <https://orcid.org/0000-0002-1463-5870>, 0000-0003-4930-3582),
  Uwe Ligges [ctb],
  Benjamin Altmann [ctb],
  Brian Ripley [ctb]
Maintainer: Jing Hua Zhao <jinghuazhao@hotmail.com>
Repository: CRAN
Date/Publication: 2026-03-09 12:40:02 UTC
Built: R 4.6.0; ; 2026-04-26 04:33:19 UTC; unix

Package: pQTLdata
Title: A Collection of Proteome Panels and Metadata
Version: 0.6
Date: 2026-3-9
Authors@R: c(
    person("Jing Hua", "Zhao", , "jinghuazhao@hotmail.com", role = c("aut", "cre"),
           comment = c(ORCID = "0000-0002-1463-5870", "0000-0003-4930-3582")),
    person("Uwe", "Ligges", role = "ctb"),
    person("Benjamin", "Altmann", role = "ctb"),
    person("Brian", "Ripley", role = "ctb")
    )
Description: It aggregates protein panel data and metadata for protein quantitative
 trait locus (pQTL) analysis using 'pQTLtools' (<https://jinghuazhao.github.io/pQTLtools/>).
 The package includes data from affinity-based panels such as 'Olink' (<https://olink.com/>) 
 and 'SomaScan' (<https://somalogic.com/>), as well as mass spectrometry-based panels from
 'CellCarta' (<https://cellcarta.com/>), 'Seer' (<https://seer.bio/>) and 'SWATH-MS'
 (<doi:10.15252/msb.20178126>). The metadata encompasses updated annotations
 and publication details.
License: MIT + file LICENSE
URL: https://jinghuazhao.github.io/pQTLdata/,
        https://github.com/jinghuazhao/pQTLdata
BugReports: https://github.com/jinghuazhao/pQTLdata/issues
Depends: R (>= 3.5.0)
Imports: knitr, Rdpack
RdMacros: Rdpack
Suggests: dplyr, grid, EnsDb.Hsapiens.v75, ensembldb, IRanges,
        org.Hs.eg.db, S4Vectors, VennDiagram
VignetteBuilder: knitr
LazyData: Yes
LazyLoad: Yes
LazyDataCompression: xz
NeedsCompilation: no
Encoding: UTF-8
RoxygenNote: 7.3.3
Packaged: 2026-03-09 11:38:17 UTC; jhz22
Author: Jing Hua Zhao [aut, cre] (ORCID:
    <https://orcid.org/0000-0002-1463-5870>, 0000-0003-4930-3582),
  Uwe Ligges [ctb],
  Benjamin Altmann [ctb],
  Brian Ripley [ctb]
Maintainer: Jing Hua Zhao <jinghuazhao@hotmail.com>
Repository: CRAN
Date/Publication: 2026-03-09 12:40:02 UTC
Built: R 4.6.0; ; 2026-04-27 19:26:12 UTC; unix

---
output: github_document
---



<img src="man/figures/logo.png" align="right" height="110" alt="" />

## A Collection of Proteome Panels and Metadata

It aggregates protein panel data and metadata for protein quantitative trait locus (pQTL) analysis using 'pQTLtools' (<https://jinghuazhao.github.io/pQTLtools/>). The package includes data from affinity-based panels such as 'Olink' (<https://olink.com/>) and 'SomaScan' (<https://somalogic.com/>), as well as mass spectrometry-based panels from 'CellCarta' (<https://cellcarta.com/>), 'Seer' (<https://seer.bio/>) and 'SWATH-MS' (<doi:10.15252/msb.20178126>). The metadata encompasses updated annotations and publication details.

## Installation

### 1. Install from R

```r
# CRAN
install.packages("pQTLdata")

# GitHub
if (!requireNamespace("remotes", quietly = TRUE)) install.packages("remotes")
remotes::install_github("jinghuazhao/pQTLdata")
```

### 2. Install from GitHub repository

```bash
git clone https://github.com/jinghuazhao/pQTLdata
R CMD INSTALL pQTLdata
```

### 3. Install from zip file

```bash
wget https://github.com/jinghuazhao/pQTLdata/archive/refs/heads/main.zip
unzip main
```

## A summary of datasets

```r
library(help=pQTLdata)
help(pQTLdata)
```

create_swath_ms <- function()
{
  HOME <- Sys.getenv("HOME")
  load(paste(HOME,"SWATH-MS","pilot","swath-ms.rda",sep="/"))
  swath_ms <- annotated_protein_matrix
  save(swath_ms,file='swath_ms.rda',compress='xz')
}

create_scallop_inf1 <- function()
# SCALLOP/INF results
{
  xlsx <- 'https://static-content.springer.com/esm/art%3A10.1038%2Fs41590-023-01588-w/MediaObjects/41590_2023_1588_MOESM5_ESM.xlsx'
  scallop_inf1 <- openxlsx::read.xlsx(xlsx, sheet=5, colNames=TRUE, skipEmptyRows=TRUE, startRow=2)
  save(scallop_inf1,file='scallop_inf1.rda',compress='xz')
}

create_SomaScan11k <- function()
# SomaScan 11K
{
  HOME <- Sys.getenv("HOME")
  SomaScan11k <-read.delim(file.path(HOME,"SomaLogic","doc","SomaScan11k.tsv"))
  save(SomaScan11k,file='SomaScan11k.rda',compress='xz')
}

create_SomaScan160410 <- function()
{
  HOME <- Sys.getenv("HOME")

# from Cardio
  SomaLogic <- read.delim(paste(HOME,"SomaLogic","doc","SOMALOGIC_Master_Table_160410_1129info.tsv",sep="/"),as.is=TRUE)
  vars <- c("SOMAS_ID_round2", "UniProt", "Target", "TargetFullName",
            "chromosome_number","start_position","end_position","EntrezGeneSymbol","ensembl_gene_id","external_gene_name")
  chrs <- c(paste(1:22),"X","Y")
  library(reshape)
  SomaScan160410 <- rename(subset(SomaLogic[vars],chromosome_number%in%chrs),
                           c(chromosome_number="chr",start_position="start",end_position="end",
                             EntrezGeneSymbol="entGene",ensembl_gene_id="ensGene",external_gene_name="extGene",
                             SOMAS_ID_round2="SOMAMER_ID"))
  out <- c("chr","start","end","ensGene","UniProt","entGene","TargetFullName","extGene","Target","UniProt","SOMAMER_ID")
  save(SomaScan160410, file="SomaScan160410.rda", compress='xz')

# from Box
  gwas <- read.csv(paste(HOME,"SomaLogic","doc","SOMALOGIC_GWAS_protein_info.csv",sep="/"),as.is=TRUE)
  gs <- merge(gwas[c("SOMAMER_ID","Target","TargetFullName")],SomaLogic160410[setdiff(out,c("Target","TargetFullName"))],by="SOMAMER_ID")
  ord <- with(gs,order(chr,start,end))
  INTERVAL_gwas <- gs[ord,out]

# INTERVAL-box.tsv is available from the SomaLogic GitHub repository
  write.table(INTERVAL_gwas,file="INTERVAL-box.tsv",quote=FALSE,row.names=FALSE,sep="\t")
}

create_Olink_qPCR <- function()
{
  Lines <- 36
  INF <- Sys.getenv("INF")
  r <- readLines(paste(INF,"doc","Olink.R",sep='/'),n=Lines)
  write(r,file=paste(Lines))
  source(paste(Lines))
  unlink(paste(Lines))
  unlink("inf1.csv")
  unlink("inf2.csv")

  panels <- list()
  for(i in 1:length(tabs))
  {
    panel <- gsub(" |-", "_", tabs[i])
    target_uniprot <- get(panel)[1:2]
    names(target_uniprot) <- c("Target","UniProt")
    panels[[i]] <- data.frame(Panel=panel,target_uniprot)
  }
  p12 <- do.call(rbind,panels)

  library(biomaRt)

# hg19/GRCh37
# listMarts()
# listEnsemblArchives()
  hg19 <- useMart(biomart= "ENSEMBL_MART_ENSEMBL", dataset="hsapiens_gene_ensembl", host = "grch37.ensembl.org")
# listDatasets(hg19)
# listAttributes(hg19)
# listFilters(hg19)
  hg19.bm <- getBM(attributes = c('uniprotswissprot', 'hgnc_symbol','chromosome_name', 'start_position', 'end_position'),
                   filters = 'uniprotswissprot',
                   values = unique(with(p12,UniProt)),
                   mart = hg19)
  hg19.bed <- subset(hg19.bm,chromosome_name%in%c(1:22,'X','Y'))
  names(hg19.bed) <- c("UniProt","gene","chr","start","end")
  Olink_qPCR <- merge(p12,hg19.bed,by="UniProt",all=TRUE)
  save(Olink_qPCR,file='Olink_qPCR.rda',compress='xz')

  single_panel <- function()
    save(Cardiometabolic, 
         Cell_Regulation,
         CVD_II,
         CVD_III,
         Development,
         Immune_Response,
         Immuno_Oncology,
         Inflammation,
         Metabolism,
         Neurology,
         Oncology_II,
         Organ_Damage,
         file='Olink_qPCR_info.rda',compress='xz')
}

create_SomaScanV4.1 <- function()
# SomaScan V4.1
{
  HOME <- Sys.getenv("HOME")
  SomaScanV4.1 <- openxlsx::read.xlsx(file.path(HOME,"SomaLogic","doc","v4.1","SomaScan v4.1 Protein Content Menu.xlsx"),
                                      sheet="SomaScanV4.1_Protein_Content", colNames=TRUE, skipEmptyRows=TRUE, cols=1:6, startRow=3)
  save(SomaScanV4.1,file='SomaScanV4.1.rda',compress='xz')
}

crewate_favicons <- function()
{
# 1. generate logo.svg

  library(gap)
  svg("logo.svg")
  INF <- Sys.getenv("INF")
  d <- read.csv(file.path(INF,"work","INF1.merge.cis.vs.trans"),as.is=TRUE)
  r <- pqtl2dplot(d)
  dev.off()

# 2. build favicons

  library(pkgdown)
  build_favicons(overwrite=TRUE)
}

create_Olink_Explore_HT <- function()
{
  f <- file.path("..","Olink","olink-explore-ht-assay-list-2023-07-12.xlsx")
  Olink_Explore_HT <- openxlsx::read.xlsx(f, sheet=1, startRow = 5, colNames=TRUE, skipEmptyRows=TRUE)
  f <- file.path("..","Olink","olink-explore-ht-assay-list.xlsx")
  Olink_Explore_HT <- openxlsx::read.xlsx(f, sheet=1, startRow = 6, colNames=TRUE, skipEmptyRows=TRUE)
  names(Olink_Explore_HT)[1] <- "Olink.ID"
  save(Olink_Explore_HT,file='../../data/Olink_Explore_HT.rda',compress='xz')
}

## ----setup, include=FALSE-----------------------------------------------------
set.seed(0)
knitr::opts_chunk$set(
  out.extra = 'style="display:block; margin: auto"',
  fig.align = "center",
  fig.path = "pQTLdata/",
  collapse = TRUE,
  comment = "#>",
  dev = "CairoPNG")

## ----echo=FALSE, message=FALSE, warning=FALSE---------------------------------
pkgs <- c("dplyr", "grid", "EnsDb.Hsapiens.v75", "ensembldb", "IRanges", "knitr", "org.Hs.eg.db", "S4Vectors", "VennDiagram")
for (p in pkgs) if (length(grep(paste("^package:", p, "$", sep=""), search())) == 0) {
    if (!requireNamespace(p)) warning(paste0("This vignette needs package `", p, "'; please install"))
}
invisible(suppressMessages(lapply(pkgs, require, character.only = TRUE)))
sys_options <- options(knitr.kable.NA=NULL)
new_options <- options(knitr.kable.NA='')

## ----caprion, echo=FALSE------------------------------------------------------
options(new_options)
accession_list <- c("P04745", "Q9GZN8", "P0C0L5", "Q96N11", "P48960",
                    "Q9NUQ9", "P04062", "P69905", "P62805", "O14745",
                    "P23381", "P54577")
updated_list <- dplyr::filter(pQTLdata::caprion,Accession %in% accession_list) |>
                dplyr::ungroup() |>
                dplyr::select(Gene,Gene.orig,Protein,Accession,ensGenes,chr,start,end)
knitr::kable(updated_list,digits=2,caption="Updated information on Caprion")
options(sys_options)

## ----overlap1, echo=FALSE, fig.cap="Overlap of Olink Explore HT, SomaScan V4.1 and Caprion", fig.height=9, fig.width=9, messages=FALSE, results="hide"----
suppressMessages(library(dplyr))
suppressMessages(library(VennDiagram))
uniprot <- list(Olink=pull(pQTLdata::Olink_Explore_HT,UniProt.ID),
                SomaScan=pull(pQTLdata::SomaScanV4.1,UniProt.ID),
                Caprion=pull(pQTLdata::caprion,Accession))
lapply(uniprot,head)
olink_somascan_caprion <- VennDiagram::venn.diagram(uniprot,filename = NULL,disable.logging = TRUE,
                                                    cex = 2.5, cat.cex = 2.5, cat.pos = c(0,0,180),
                                                    height=8,width=8,units="in")
grid.newpage()
grid.draw(olink_somascan_caprion)

## ----overlap2, echo=FALSE, fig.cap="Overlap of Olink Explore HT, SomaScan 11K and Caprion", fig.height=9, fig.width=9, messages=FALSE, results="hide"----
suppressMessages(library(dplyr))
suppressMessages(library(VennDiagram))
uniprot <- list(Olink=pull(pQTLdata::Olink_Explore_HT,UniProt.ID),
                SomaScan=pull(pQTLdata::SomaScan11k,UniProt.ID),
                Caprion=pull(pQTLdata::caprion,Accession))
lapply(uniprot,head)
olink_somascan_caprion <- VennDiagram::venn.diagram(uniprot,filename = NULL,disable.logging = TRUE,
                                                    cex = 2.5, cat.cex = 2.5, cat.pos = c(0,0,180),
                                                    height=8,width=8,units="in")
grid.newpage()
grid.draw(olink_somascan_caprion)

## ----inf1, echo=FALSE---------------------------------------------------------
options(new_options)
knitr::kable(pQTLdata::inf1,digits=2,caption="Olink/inflammation panel")
options(sys_options)

## ----refdata, eval=requireNamespace("EnsDb.Hsapiens.v75", quietly=TRUE), warnings=FALSE----
options(new_options)
ensembldb::metadata(EnsDb.Hsapiens.v75)
ensembldb::keytypes(EnsDb.Hsapiens.v75)
exon_info <- ensembldb::exons(EnsDb.Hsapiens.v75)
gene_info <- ensembldb::genes(EnsDb.Hsapiens.v75)
transcript_info <- ensembldb::transcripts(EnsDb.Hsapiens.v75)
colnames(S4Vectors::mcols(gene_info))
colnames(S4Vectors::mcols(transcript_info))
overlaps <- IRanges::findOverlaps(transcript_info, gene_info)
overlapping_transcripts <- transcript_info[queryHits(overlaps)]
overlapping_genes <- gene_info[subjectHits(overlaps)]
overlap_data <- data.frame(
  transcript_id = mcols(overlapping_transcripts)$tx_id,
  gene_id = S4Vectors::mcols(overlapping_genes)$gene_id,
  gene_name = S4Vectors::mcols(overlapping_genes)$gene_name,
  start = pmax(start(overlapping_transcripts), start(overlapping_genes)),
  end = pmin(end(overlapping_transcripts), end(overlapping_genes))
)
gene_symbols <- c("BRCA1", "TP53")
gene_data <- subset(overlap_data,gene_name%in%gene_symbols,select=-c(gene_id,gene_name))
cols <- c("UNIPROTID","PROTEINID","GENEID","GENENAME","SEQNAME","TXID")
info <- ensembldb::select(EnsDb.Hsapiens.v75, keys = gene_symbols, 
                          columns = cols, keytype = "SYMBOL") |>
        dplyr::left_join(head(gene_data,15),by=c('TXID'='transcript_id')) |>
        subset(!is.na(UNIPROTID)&!is.na(start)&!is.na(end))
knitr::kable(head(info,15),caption="Annotation for BRCA1 and TP53")
keytypes(org.Hs.eg.db)
uniprot_ids <- ensembldb::select(org.Hs.eg.db, keys = gene_symbols, columns = "UNIPROT", keytype = "SYMBOL")
options(sys_options)

create_hg19 <- function()
{
  library(OrganismDbi)
  library(TxDb.Hsapiens.UCSC.hg19.knownGene)
  odb <- OrganismDbi::makeOrganismDbFromTxDb(txdb = TxDb.Hsapiens.UCSC.hg19.knownGene)
  print(odb)
  cols <- AnnotationDbi::columns(odb)
  print(cols)
  tx <- GenomicFeatures::transcripts(odb, columns = c("UNIPROT", "SYMBOL", "ENSEMBL"))
  head(tx)
  chrs <- paste0("chr", c(1:22, 'X', 'Y'))
  hg19 <- subset(as.data.frame(tx), seqnames %in% chrs & !is.na(UNIPROT))
  head(hg19)
  names(hg19)[1] <- "chr"
  head(hg19)
  save(hg19,file='hg19.rda',compress='xz')
}

create_hg19_makeOrganismPackage <- function()
{
  library(OrganismDbi)
  gd <- list(join1 = c(GO.db="GOID", org.Hs.eg.db="GO"),
             join2 = c(org.Hs.eg.db = "ENTREZID", TxDb.Hsapiens.UCSC.hg19.knownGene = "GENEID"))
  destination <- tempfile()
  dir.create(destination)
  makeOrganismPackage(pkgname = "Homo.sapiens.hg19", graphData = gd,
                      organism = "Homo sapiens", version = "1.0.0",
                      maintainer = "Maintainer<maintainer@email>",
                      author = "Author Name", destDir = destination,
                      license = "Artistic-2.0")
  library(Homo.sapiens.hg19)
  Homo.sapiens.hg19
  cols <- columns(Homo.sapiens.hg19)
  cols
  tx <- transcripts(Homo.sapiens.hg19, columns=c("UNIPROT","SYMBOL","ENSEMBL"))
  chrs <- paste0("chr",c(1:22,'X','Y'))
  hg19 <- subset(as.data.frame(tx),seqnames %in% chrs & !is.na(UNIPROT))
  names(hg19)[1] <- "chr"
  save(hg19,file='hg19.rda',compress='xz')
}

gs <- function()
# Full genome sequence
{
  suppressMessages(library(BSgenome.Hsapiens.UCSC.hg19))
  print(Hsapiens)
  suppressMessages(library(BSgenome))
  getSeq(Hsapiens,seqnames(Hsapiens))
}

hgs <- gs()
print(hgs)

create_hg19Tables <- function()
{
  INF <- Sys.getenv("INF")
  tsv <- paste(INF,"docs","hg19Tables.tsv",sep="/")
  hg19Tables <- subset(read.delim(tsv,as.is=TRUE),!grepl("hap",X.chrom)&!grepl("Un",X.chrom)&!grepl("random",X.chrom)&!grepl(";",geneName)&geneName!="")
  vars <- setdiff(names(hg19Tables),
                  c("protFullNames","protShortNames","protAltFullNames","protAltShortNames","refSeq","refSeqProt","entrezGene","ensTrans","ensProt"))
  hg19Tables <- hg19Tables[vars]
  save(hg19Tables,file="hg19Tables.rda",compress='xz')
}

create_Olink_Explore_3072 <- function()
{
  f <- file.path("..","Olink","assay-list-olink-explore-3072.xlsx")
  Olink_Explore_3072 <- openxlsx::read.xlsx(f, sheet=1, startRow = 3, colNames=TRUE, skipEmptyRows=TRUE)
  save(Olink_Explore_3072,file='../../data/Olink_Explore_3072.rda',compress='xz')
}

sts <- function()
# INTERVAL SomaLogic results
{
  dir <- 'https://static-content.springer.com/esm/art%3A10.1038%2Fs41586-018-0175-2/MediaObjects/'
  file <- '41586_2018_175_MOESM4_ESM.xlsx'
  xlsx <- paste0(dir,file)
  st4.1 <- openxlsx::read.xlsx(xlsx, sheet=4, colNames=TRUE, skipEmptyRows=TRUE,
                               cols=c(1:16,26:28), rows=c(5:1986))
  s t4.2 <- openxlsx::read.xlsx(xlsx, sheet=4, colNames=TRUE, skipEmptyRows=TRUE,
                              cols=c(17:25,29:31), rows=c(6:1986))
  st4 <- cbind(st4.1,st4.2)
  save(st4,file='st4.rda',compress='xz')
  st5 <- openxlsx::read.xlsx(xlsx, sheet=5, colNames=TRUE, skipEmptyRows=TRUE,
                             cols=c(1:19), rows=c(3:2746))
  st6.1 <- openxlsx::read.xlsx(xlsx, sheet=6, colNames=TRUE, skipEmptyRows=TRUE,
                             cols=c(1:11:13), rows=c(3:167))
  st6.2 <- openxlsx::read.xlsx(xlsx, sheet=6, colNames=TRUE, skipEmptyRows=TRUE,
                             cols=c(14:20), rows=c(4:167))
  st6 <- cbind(st6.1,st6.2)
  save(st6,file='st6.rda',compress='xz')
  replicates <- merge(st4[,c(1:12,26:28)],st6[,c(1:10,17:20)],
                      by=c("Locus.ID","UniProt","Chr","Pos","SOMAmer.ID"))
  line_to_edit <- with(replicates,Locus.ID=="3_59"|Locus.ID=="5_29")
  replicates[line_to_edit,"UniProt"] <- "P29460"

# However, it is unclear UniProts in ST6 were selected from which of the panels
  INF <- Sys.getenv("INF")
  INF1_merge <- merge(inf1,
                      read.delim(file.path(INF,"work","INF1.merge-rsid"),as.is=TRUE),
                      by="prot")
  INF1_uniprot <- unique(with(INF1_merge,uniprot))
  st6_replicates <- subset(replicates,UniProt %in% INF1_uniprot)
  table(subset(st6_replicates,UniProt %in% INF1_uniprot)$Replicates)

# side information on cvd2, cvd3, inf1
  olink <- scan(file.path(INF,"doc","olink.prot.list.txt"),"")
  olink_uniprot <- unlist(lapply(strsplit(olink,"___"),'[[',2))
  dim(subset(replicates,UniProt %in% olink_uniprot))

  z <- with(st6_replicates,{
    chr <- st6_replicates[["Chr"]]
    pos <- st6_replicates[["Pos"]]
    a1 <- st6_replicates[["Effect.Allele.(EA)"]]
    a2 <- st6_replicates[["Other.Allele.(OA)"]]
    cbind(UniProt,snpid=chr_pos_a1_a2(chr,pos,a1,a2))
  })

  doubles <- c("P29460","Q9NPF7","Q14213","Q8NEV9")
  subset(inf1,uniprot %in% doubles)
  write.table(merge(inf1,z,by.x="uniprot",by.y="UniProt")[c("snpid","prot","uniprot")],
              file="SomaLogic.id3",col.names=FALSE,row.names=FALSE,quote=FALSE)

  st18 <- openxlsx::readWorkbook(xlsx,sheet="ST18 - proteins assayed",startRow=3)
  save(st18,file='st18.rda',compress='xz')
  st20 <- openxlsx::read.xlsx(xlsx, sheet=20, colNames=TRUE, skipEmptyRows=TRUE,
                            cols=c(1:10), rows=c(3:786))
  ov <- intersect(unique(st20$UniProt),inf1$uniprot)
  ovv <- subset(st20,UniProt%in%ov)
  dim(ovv)
}

create_Olink_Target_96 <- function()
{
  library(openxlsx)
  fp <- file.path("..","Olink","Olink-Target-96-Assay-List.xlsx")
  sn <- getSheetNames(fp)[1]
  as <- lapply(sn, function(s) {read.xlsx(fp, sheet = s, startRow = 2)}) |>
               setNames(sn)
  lapply(as,tail,1)
  d <-  as[[1]] |>
        as.data.frame()
  Olink_Target_96 <- d[-nrow(d), ] |>
                     setNames(c("UniProt","Protein","Panel"))
  save(Olink_Target_96, file=file.path("..","..","data","Olink_Target_96.rda"),compress="xz")
}

create_inf1 <- function()
{
  library(gap)
  load("biomaRt.rda")
  v <- c("ensembl_gene_id","chromosome_name","start_position","end_position","hgnc_symbol","uniprotswissprot")
  FGF5_CD6 <- unique(subset(biomaRt[v],hgnc_symbol%in%c("FGF5","CD6")))
  FGF5_CD6["uniprotswissprot"] <- with(subset(inf1,gene%in%c("FGF5","CD6")),uniprot)
  s <- unique(subset(biomaRt[v],uniprotswissprot%in%inf1$uniprot))
  t <- merge(inf1,rbind(s,FGF5_CD6)[c("ensembl_gene_id","uniprotswissprot")],by.x="uniprot",by.y="uniprotswissprot")
  t[with(t,uniprot)%in%c("Q8NF90","Q8WWJ7"),"uniprot"] <- c("P12034","P30203")

# The following reflects recent changes at www.uniprot.org
  g <- c("CCL2", "CCL7", "CCL8", "CCL11", "CCL13", "CXCL6")
  p <- c("MCP.1", "MCP.3", "MCP.2", "CCL11", "MCP.4", "CXCL6")
  pg <- data.frame(prot=p,alt_name=g)
  inf1 <- merge(t,pg,by="prot",all.x=TRUE)
# The following reflects recent changes at https://www.ensembl.org/
  sevens <- "
  ENSG00000131142 CCL25 19 8052318 8062660
  ENSG00000125735 TNFSF14 19 6661253 6670588
  ENSG00000275302 CCL4 17 36103827 36105621
  ENSG00000274736 CCL23 17 36013056 36017972
  ENSG00000013725 CD6 11 60971680 61020377
  ENSG00000138675 FGF5 4 80266639 80336680
  ENSG00000277632 CCL3 17 36088256 36090169
  "
  updates <- as.data.frame(scan(file=textConnection(sevens),what=list("","",0,0,0)))
  names(updates) <- c("ensGene","gene","chromosome","start38","end38")
  inf1 <- merge(inf1,updates,by="gene",all.x=TRUE)

  save(inf1,file="inf1.rda",compress='xz')
}

create_caprion <- function()
{
  HOME <- Sys.getenv("HOME")
  load(paste(HOME,"Caprion","pilot","caprion.rda",sep="/"))
  caprion <- protein_list
  library(biomaRt)
  library(dplyr)
  ensembl <- useMart("ensembl", dataset = "hsapiens_gene_ensembl")
  gene_ensembl <- getBM(
    attributes = c("hgnc_symbol", "ensembl_gene_id", "chromosome_name", "start_position", "end_position"),
    filters = "hgnc_symbol",
    values = pQTLdata::caprion$Gene,
    mart = ensembl
  )
  caprion_ensembl <- left_join(caprion, filter(gene_ensembl,chromosome_name %in% c(paste(1:22),"X")),
                               by = c("Gene" = "hgnc_symbol")) %>%
                      group_by(Gene,Protein,Accession,Protein.Description,GO.Cellular.Component,GO.Function,GO.Process) %>%
                      summarize(ensGenes=paste(ensembl_gene_id,collapse=";"),
                                chrom=unique(chromosome_name),
                                starts=paste(start_position,collapse=";"),
                                ends=paste(end_position,collapse=";"),
                                start=min(start_position),end=max(end_position))
  caprion_ensembl[-c(1,4:7)] |> filter(ensGenes=="NA")
  ## A tibble: 12 × 8
  ## Groups:   Protein, Accession [12]
  #   Protein     Accession ensGenes chrom starts ends  start   end
  #   <chr>       <chr>     <chr>    <chr> <chr>  <chr> <int> <int>
  # 1 AMY1_HUMAN  P04745    NA       NA    NA     NA       NA    NA
  # 2 CT027_HUMAN Q9GZN8    NA       NA    NA     NA       NA    NA
  # 3 CO4B_HUMAN  P0C0L5    NA       NA    NA     NA       NA    NA
  # 4 CG026_HUMAN Q96N11    NA       NA    NA     NA       NA    NA
  # 5 CD97_HUMAN  P48960    NA       NA    NA     NA       NA    NA
  # 6 FA49B_HUMAN Q9NUQ9    NA       NA    NA     NA       NA    NA
  # 7 GLCM_HUMAN  P04062    NA       NA    NA     NA       NA    NA
  # 8 HBA_HUMAN   P69905    NA       NA    NA     NA       NA    NA
  # 9 H4_HUMAN    P62805    NA       NA    NA     NA       NA    NA
  #10 NHRF1_HUMAN O14745    NA       NA    NA     NA       NA    NA
  #11 SYWC_HUMAN  P23381    NA       NA    NA     NA       NA    NA
  #12 SYYC_HUMAN  P54577    NA       NA    NA     NA       NA    NA

  Sys.setlocale("LC_CTYPE", "en_US.UTF-8")
  library(httr)
  library(jsonlite)
  accession_list <- c("P04745", "Q9GZN8", "P0C0L5", "Q96N11", "P48960",
                      "Q9NUQ9", "P04062", "P69905", "P62805", "O14745",
                      "P23381", "P54577")
  base_url <- "https://www.uniprot.org/uniprot/"
  results <- list()
  for (accession in accession_list) {
      url <- paste0(base_url, accession, ".json")
      response <- GET(url)
      print(paste("Accessing:", url))
      print(paste("Status Code:", status_code(response)))
      if (status_code(response) == 200) {
          raw_content <- content(response, "text")
          utf8_content <- iconv(raw_content, from = "latin1", to = "UTF-8")
          data <- fromJSON(utf8_content)
          print(paste("Data for:", accession))
          print(data)
          if ("inactiveReason" %in% names(data)) {
              merged_ids <- data$inactiveReason$mergeDemergeTo
              if (length(merged_ids) > 0) {
                  results[[accession]] <- merged_ids
              } else {
                  results[[accession]] <- "No merged IDs"
              }
          } else {
              results[[accession]] <- "Active, no merged IDs"
          }
      } else {
          results[[accession]] <- paste("Error: Status code", status_code(response))
      }
  }
  print(results)
  library(httr)
  library(jsonlite)
  base_url <- "https://www.uniprot.org/uniprot/"
  all_ensembl_gene_ids <- list()
  for (accession in accession_list) {
      url <- paste0(base_url, accession, ".json")
      response <- GET(url)
      if (status_code(response) == 200) {
          raw_content <- content(response, "text")
          utf8_content <- iconv(raw_content, from = "latin1", to = "UTF-8")
          data <- fromJSON(utf8_content)  # Parse JSON
          ensembl_ids <- NULL
          if ("genes" %in% names(data)) {
              for (gene in data$genes) {
                  if ("identifier" %in% names(gene)) {
                      if (grepl("ENSEMBL", gene$identifier)) {
                          ensembl_ids <- c(ensembl_ids, gene$identifier)
                      }
                  }
              }
          }
          if (is.null(ensembl_ids) || length(ensembl_ids) == 0) {
              if ("secondaryAccessions" %in% names(data)) {
                  ensembl_ids <- data$secondaryAccessions
              }
          }
          if (is.null(ensembl_ids) || length(ensembl_ids) == 0) {
              all_ensembl_gene_ids[[accession]] <- "Ensembl gene ID not available"
          } else {
              all_ensembl_gene_ids[[accession]] <- ensembl_ids
          }
      } else {
          all_ensembl_gene_ids[[accession]] <- paste("Error: Status code", status_code(response))
      }
  }
  print(all_ensembl_gene_ids)
  all_ensembl_gene_ids$P04745 <- results$P04745

  uniprot_list <- list(
    P04745 = c("P0DTE7", "P0DUB6", "P0DTE8"),
    Q9GZN8 = c("A8K4J0", "D3DVX8", "Q5JX81", "Q9NWX3"),
    P0C0L5 = c("A2BHY4", "P01028", "P78445", "Q13160", "Q13906", "Q14033", "Q14835", "Q6U2E9",
               "Q6U2G1", "Q6U2I5", "Q6U2L1", "Q6U2L7", "Q6U2L9", "Q6U2M5", "Q6VCV8", "Q96SA7", "Q9NPK5", "Q9UIP5"),
    Q96N11 = c("Q9BQ43"),
    P48960 = c("A8K7Z4", "B2RBJ9", "O00718", "O76101", "Q8NG72", "Q8TBQ7"),
    Q9NUQ9 = c("Q96AZ5", "Q9NW21", "Q9NZE7"),
    P04062 = c("A8K796", "B7Z5G2", "B7Z6S1", "J3KQG4", "J3KQK9", "Q16545", "Q4VX22", "Q6I9R6", "Q9UMJ8"),
    P69905 = c("P01922", "Q1HDT5", "Q3MIF5", "Q53F97", "Q96KF1", "Q9NYR7", "Q9UCM0"),
    P62805 = c("A2VCL0", "P02304", "P02305", "Q6DRA9", "Q6FGB8", "Q6NWP7"),
    O14745 = c("B3KY21", "O43552", "Q86WQ5"),
    P23381 = c("A6NGN1", "A6NID3", "P78535", "Q502Y0", "Q53XB6", "Q9UDI5", "Q9UDL3"),
    P54577 = c("B3KWK4", "D3DPQ4", "O43276", "Q53EN1")
  )
  get_gene_positions <- function(uniprot_ids) {
    results <- getBM(attributes = c("uniprotswissprot", "ensembl_gene_id", 
                                    "hgnc_symbol", "chromosome_name", 
                                    "start_position", "end_position"),
                     filters = "uniprotswissprot",
                     values = uniprot_ids, 
                     mart = ensembl)
    return(results)
  }
  get_gene_positions_ensembl <- function(uniprot_ids) {
    ensembl <- useMart("ensembl", dataset = "hsapiens_gene_ensembl")
    results <- getBM(
      attributes = c("uniprotswissprot", "ensembl_gene_id", "hgnc_symbol", "chromosome_name", "start_position", "end_position"),
      filters = "uniprotswissprot",
      values = uniprot_ids,
      mart = ensembl
    )
    return(results)
  }
  all_gene_positions <- list()
  for (uniprot_id in accession_list) {
    gene_positions <- get_gene_positions_ensembl(uniprot_id)
    if (nrow(gene_positions) > 0) {
      all_gene_positions[[uniprot_id]] <- gene_positions
    } else {
      all_gene_positions[[uniprot_id]] <- "No data found"
    }
  }
  all_gene_positions$P04745 <- get_gene_positions(uniprot_list$P04745)
  print(all_gene_positions)
  do.call("rbind",all_gene_positions)
  all_gene_positions[[1]]$ uniprotswissprot <- "P04745"
  collapsed_data <- lapply(all_gene_positions, function(df) {
                           df %>%
                           mutate(chromosome_name = if_else(grepl("HS", chromosome_name), "6", as.character(chromosome_name))) %>%
                           group_by(uniprotswissprot) %>%
                           summarise(
                              ensembl_gene_id = paste(ensembl_gene_id, collapse = ";"),
                              hgnc_symbol = paste(hgnc_symbol, collapse = ";"),
                              chrs = paste(unique(chromosome_name), collapse = ";"),
                              starts = paste(start_position, collapse = ";"),
                              ends = paste(end_position, collapse = ";"),
                              start = min(as.numeric(start_position), na.rm = TRUE),
                              end = max(as.numeric(end_position), na.rm = TRUE)
                           )
                    })
  print(collapsed_data)
  caprion_modified <- left_join(caprion_ensembl, do.call("rbind", collapsed_data), by = c("Accession" = "uniprotswissprot")) %>%
                      mutate(ensGenes = na_if(ensGenes, "NA"),
                             starts = coalesce(starts.x, starts.y),
                             ends = coalesce(ends.x, ends.y),
                             ensGenes = coalesce(ensGenes, ensembl_gene_id),
                             Gene = coalesce(Gene, hgnc_symbol),
                             Gene.orig = coalesce(Gene, hgnc_symbol),
                             chr = coalesce(chrom, chrs),
                             start = coalesce(start.x, start.y),
                             end = coalesce(end.x, end.y)) %>%
                      select(-c(chrs, starts.x, ends.x, starts.y, ends.y, start.x, start.y, end.x, end.y, hgnc_symbol, ensembl_gene_id))
  caprion <- caprion_modified
  lines <- c(46,137,441,452)
  caprion[lines,"Gene"]
  caprion[lines,"Gene"] <- c("AMY1","C4B","HBA","HIST")
  save(caprion,file='caprion.rda',compress='xz')
}

caprion_legacy <- function()
{
  # Check the resulting data frame
  print(caprion_modified)
  # https://www.uniprot.org/
  # P04745 ->  P0DTE7, P0DTE8, and P0DUB6
  manual_check <- '
  P04745,AMY1A;AMY1B;AMY1C,
  Q9GZN8,ADISSP,
  P0C0L5,C4B;C4B_2,
  Q96N11,INTS15,
  P48960,ADGRE5, 
  Q9NUQ9,CYRIB,
  P04062,GBA1,
  P69905,HBA1;HBA2,
  P62805,H4C1;H4C2;H4C3;H4C4;H4C5;H4C6;H4C8;H4C9;H4C11;H4C12;H4C13;H4C14;H4C15;H4C16,
  O14745,NHERF1,
  P23381,WARS1,
  P54577,YARS1'

  library(pQTLdata)
  nodup <- function(x) sapply(x, function(s) unique(unlist(strsplit(s,";")))[1])
  ucsc <- hg19Tables %>%
          group_by(acc) %>%
          summarize(
               prot=paste(uniprotName,collapse=";"),
               chrom=paste(X.chrom,collapse=";"),
               start=min(chromStart),
               end=max(chromEnd),
               gene=paste(geneName,collapse=";")
          )
  # uniprot IDs are the same if proteins are the same
  p <- select(caprion,Accession,Protein,Gene) %>%
       left_join(ucsc,by=c("Protein"="prot")) %>%
       select(Accession,Protein,Gene,gene,acc,chrom,start,end)
  # however even with same uniprotID their protein names may be different
  u <- select(caprion_ensembl,-c(chrom,start,end)) %>%
       left_join(ucsc,by=c("Accession"="acc")) %>%
       mutate(chrom=nodup(chrom)) %>%
       filter(!is.na(Protein))
  # The following check shows merge by uniprot is more sensible
  filter(p,Accession!=acc)
  filter(p,Gene!=gene)
  filter(p,is.na(start))
  filter(u,Protein!=prot)
  umiss <- with(u,is.na(start))
  pull(u[umiss,],Accession)
  # "P04745" "P02655" "P55056" "P0C0L5" "P62805" "P69905"
  # confirmed form UniProt.org that Gene is more up-to-date
  # (obsolute), (APOC2), (APOC4), (C4B; C4B_2), (H4C1; H4C2; H4C3; H4C4; H4C5; H4C6; H4C8; H4C9; H4C11; H4C12; H4C13; H4C14; H4C15; H4C16), (HBA1; HBA2)
  # They are amended according to glist-hg19 in the function below.
  u[umiss,"Protein"] <- paste0(c("AMY1","APOC2","APOC4","CO4B","H4","HBA"),"_HUMAN")
  u[umiss,"Gene"] <- c("AMY1","APOC2","APOC4","CO4B","H4C","HBA")
  u[umiss,"chrom"] <- c("chr1","chr19","chr19","chr6","chr6","chr16")
  u[umiss,"start"] <- c(104198140,45449238,45445494,31949833,26021906,222845)
  u[umiss,"end"] <- c(104301311,45452822,45452822,32003195,27841289,227520)
  caprion_modified <- rename(u,chrom.u=chrom,start.u=start,end.u=end)
  a <- u[umiss,] %>%
       transmute(acc=Accession,prot=Protein,gene=Gene,chrom,start,end)
  ucsc2 <- ucsc %>%
           mutate(prot=nodup(prot),chrom=nodup(chrom),gene=nodup(gene)) %>%
           bind_rows(a)
  caprion_ucsc_modified <- left_join(caprion_modified,ucsc2) %>%
                           mutate(chrom=if_else(is.na(chrom),paste(unique(strsplit(chrom.u, ";")[[1]]), collapse = ";"),chrom),
                                  start=if_else(is.na(start),start.u,start),
                                  end=if_else(is.na(end),end.u,end)) %>%
                           select(-c(acc,prot,gene,chrom.u,start.u,end.u))
  quadruple <- function(d,label)
               with(d,data.frame(Gene=label,chrom=paste0("chr",min(chr)),start=min(start),end=max(end)))

  glist_refgene <- function()
  {
  # glist-hg19 lookup
    INF <- Sys.getenv("INF")
    glist_hg19 <- read.table(file.path(INF,"csd3","glist-hg19"),col.names=c("chr","start","end","gene")) %>%
                  filter(! chr %in% c("XY","Y"))
    X <- with(glist_hg19,chr=="X")
    glist_hg19 <- mutate(glist_hg19,chrom=paste0("chr",chr))
    glist_hg19[X,"chr"] <- "23"
    subset(glist_hg19,grepl("^AMY1",gene))
    subset(glist_hg19,grepl("^C4B",gene)&chr=="6")
    subset(glist_hg19,grepl("^HIST1H4|^HIST2H4[A-B]|HIST4H4",gene))
    subset(glist_hg19,grepl("^HBA",gene))
    AMY1 <- quadruple(subset(glist_hg19,grepl("^AMY1",gene)),label="AMY")
    C4B <- quadruple(subset(glist_hg19,grepl("^C4B",gene)&chr=="6"),label="C4B")
    HIST <- quadruple(subset(glist_hg19,grepl("^HIST1H4[A-L]",gene)),label="HIST")
    HBA <- quadruple(subset(glist_hg19,grepl("^HBA",gene)),label="HBA")
    glist_hg19 <- glist_hg19 %>%
                  group_by(gene) %>%
                  summarize(chrom=paste(chrom,collapse=";"),start=min(start),end=max(end)) %>%
                  mutate(chrom=nodup(chrom))
  # refgenes
    load("~/cambridge-ceu/turboman/turboman_hg19_reference_data.rda")
    refgenes <- refgene_gene_coordinates_h19 %>%
                mutate(chromosome=paste0("chr",chromosome)) %>%
                setNames(c("chrom","start","end","gene","mid")) %>%
                bed_intersect(glist_hg19)
  }
}

suppressMessages(library(dplyr))
suppressMessages(library(ggplot2))
suppressMessages(library(OlinkAnalyze))

document_example <- function()
# https://github.com/Olink-Proteomics/OlinkRPackage
{
  # visualize the NPX distribution per sample per panel, example for one panel
  olink_dist_plot(npx_data1 %>% filter(Panel == 'Olink Cardiometabolic')) +
    theme(axis.text.x = element_blank(),
          axis.ticks.x = element_blank()) +
    scale_fill_manual(values = c('turquoise3', 'red'))

  olink_qc_plot(npx_data1 %>% filter(Panel == 'Olink Cardiometabolic')) +
  scale_color_manual(values = c('turquoise3', 'red'))

  # identify bridge samples
  bridge_samples <- intersect(x = npx_data1$SampleID,
                              y = npx_data2$SampleID)

  # bridge normalize
  bridge_normalized_data <- olink_normalization(df1 = npx_data1,
                            df2 = npx_data2,
                            overlapping_samples_df1 = bridge_samples,
                            df1_project_nr = "20200001",
                            df2_project_nr = "20200002",
                            reference_project = "20200001")
  # t-test npx_data1
  ttest_results_NPX1 <- olink_ttest(df = npx_data1,
                                    variable = "Treatment")

  # select names of the top #10 most significant proteins
  ttest_sign_NPX1 <- ttest_results_NPX1 %>%
  head(n=10) %>%
  pull(OlinkID)

  # volcano plot with annotated top #10 most significant proteins
  olink_volcano_plot(p.val_tbl = ttest_results_NPX1,
                     olinkid_list = ttest_sign_NPX1) +
  scale_color_manual(values = c('turquoise3', 'red'))
}

# MGH data

# https://www.olink.com/application/mgh-covid-19-study/

HOME <- Sys.getenv("HOME")
dir <- file.path(HOME,"R","work","MGH","MGH_Olink_COVID_Apr_27_2021/")

NPX_data <- read_NPX(filename = file.path(dir,"MGH_COVID_OLINK_NPX.txt"))

# visualize the NPX distribution per sample per panel, example for one panel
olink_dist_plot(NPX_data %>% filter(Panel == 'Cardiometabolic')) +
  theme(axis.text.x = element_blank(),
        axis.ticks.x = element_blank()) +
  scale_fill_manual(values = c('turquoise3', 'red'))

olink_qc_plot(NPX_data %>% filter(Panel == 'Cardiometabolic')) +
  scale_color_manual(values = c('turquoise3', 'red'))

create_see1980 <- function()
{
  suppressMessages(library(dplyr))
  require(openxlsx)
  url <- "https://www.biorxiv.org/content/biorxiv/early/2024/06/01/2024.05.27.596028/DC4/embed/media-4.xlsx?download=true"
  seer1980 <- read.xlsx(url,sheet=2,colNames=TRUE,skipEmptyRows=TRUE,startRow=3) %>%
              select(-c(CHR,SNP,POS,EFF,N,BETA,STAT,P,LAMBDA,cis))
  save(seer1980,file="seer1980.rda",compress="xz")
}

create_biomaRt <- function()
{
  library(biomaRt)
  listEnsemblArchives()
  ensembl <- useMart("ensembl", dataset="hsapiens_gene_ensembl", host="grch37.ensembl.org", path="/biomart/martservice")
  attr <- listAttributes(ensembl)
  subset(attr,grepl("ensembl",name))
  g <- c('ensembl_gene_id', 'chromosome_name', 'start_position', 'end_position', 'description', 'hgnc_symbol')
  t <- c('ensembl_transcript_id', 'transcription_start_site', 'transcript_start', 'transcript_end')
  u <- "uniprotswissprot"
  gtu <- getBM(attributes = c(g,t,u), mart = ensembl)
  biomaRt <- subset(gtu,uniprotswissprot!=""&chromosome_name%in%c(1:22,"X","Y"))
  save(biomaRt,file='biomaRt.rda',compress='xz')
}

#!/usr/bin/bash

function create_package()
{
  Rscript -e 'library(usethis);create_package("pQTLdata");use_mit_license()'
}

function create_github_repository()
{
  export user=jinghuazhao
  export token=$(awk "NR==2" ~/doc/access)
  export API=https://api.github.com
  export header="Accept: application/vnd.github.v3+json"
  export name=pQTLdata

# 1. create the repository
  curl -X POST -u $user:$token -H "$header" -d '{"name": "'"$name"'"}' $API/user/repos

# 2. list the repository
  curl -H "$header" $API/repos/$user/$name

# 3. delete the repository
# curl -X DELETE -u $user:$token -H "$header" $API/repos/$user/$name

# 4. customise settings and commit
  git config --global user.email "jinghuazhao@hotmail.com"
  git config --global user.name "jinghuazhao@github.com"
  git config --global url."https://jinghuazhao@github.com".insteadOf "https://github.com"
  git init
  git branch -M main
  git remote add origin git@github.com:jinghuazhao/pQTLdata.git
  git push --set-upstream origin main

# 5. pkgdown site
  Rscript -e '
      library(pkgdown)
      init_site()
      devtools::document()
      build_site()
  '
}

# 6. automate commitments

module load ceuadmin/R
Rscript -e 'knitr::knit("README.Rmd");devtools::document();pkgdown::build_site()'

for d in pQTLdata
do
    if [ -d vignettes/${d} ]; then
       rm -rf docs/articles/${d}
       mv vignettes/${d} docs/articles/
    fi
done

for f in .gitignore .Rbuildignore .Rinstignore docs/ pkgdown/ \
         data/ DESCRIPTION INDEX inst/ LICENSE LICENSE.md man/ vignettes/ \
         NAMESPACE NEWS.md R/ README.*
do
  echo adding ${f}
  git add ${f}
  git commit -m "${f}"
done
git push
du -h --exclude .git --exclude docs

#!/usr/bin/env bash

set -e
src="$HOME/pQTLdata"
dst="$HOME/R/pQTLdata"
log_file="$HOME/work/pQTLdata_copy.log"

remove_destination() {
  if [ -d "$dst" ]; then
    echo "$(date '+%Y-%m-%d %H:%M:%S') - Removing existing destination directory: $dst" | tee -a "$log_file"
    rm -rf "$dst"
  elif [ -e "$dst" ]; then
    echo "$(date '+%Y-%m-%d %H:%M:%S') - Removing existing file at destination: $dst" | tee -a "$log_file"
    rm -f "$dst"
  fi
}
{
  echo "----------------------------------------"
  echo "Copy Operation Started: $(date '+%Y-%m-%d %H:%M:%S')"
  remove_destination
  echo "Creating destination directory: $dst" | tee -a "$log_file"
  mkdir -p "$dst"
  echo "Changing to source directory: $src" | tee -a "$log_file"
  cd "$src" || { echo "Error: Source directory not found: $src"; exit 1; }
  echo "Copying files excluding 'docs', 'pkgdown', and all hidden files/directories" | tee -a "$log_file"
  rsync -av --exclude='docs/' --exclude='pkgdown/' --exclude='.*' --exclude='*/.*' --exclude='README.Rmd' --exclude='LICENSE.md' ./ "$dst/"
  echo "Copy Operation Completed Successfully: $(date '+%Y-%m-%d %H:%M:%S')" | tee -a "$log_file"
} >> "$log_file" 2>&1

echo "Files copied successfully from $src to $dst. Check the log file at $log_file for details."

module load ceuadmin/R
cd ~/R
export version=$(awk '/Version/{print $2}' $src/DESCRIPTION)
echo "Now, build, install and check pQTLdata $version"
R CMD build --compact-vignettes=both --md5 --resave-data --log pQTLdata
R CMD INSTALL --compact-docs --data-compress=xz pQTLdata_${version}.tar.gz
R CMD check --as-cran pQTLdata_${version}.tar.gz

#!/usr/bin/bash

export npx=${HOME}/COVID-19/Olink-NGS/tmp_raw_data/20200292_Danesh_NPX_2020-06-03.csv
(
  cut -d';' -f4,5,7 ${npx} | \
  head -1
  join -t$';' <(cut -d';' -f4 ${npx} | sed '1d' | sort | uniq) \
              <(cut -d';' -f4,5,7 ${npx} | sed '1d' | sort | uniq)
) > NPX.csv

R --no-save -q <<END
  Olink_Explore_1536 <- read.csv("NPX.csv",sep=';')
  save(Olink_Explore_1536,file='../../data/Olink_Explore_1536.rda',compress='xz')
END

rm NPX.csv

#!/usr/bin/bash

function handle_iconv()
{
  iconv -l
# caught ï»¿ in front of @article{sun18, in refs.bib
  iconv -f ISO-8859-1 -t UTF-8 refs.bib > refs.txt
  diff refs.bib refs.txt
# caught \u2265 as in \item{\code{Uncorrelated.with.PAV.(r2≥0.1)}}{Uncorrelated with PAV}
  iconv -f ISO-8859-1 -t UTF-8 utils.R > utils.txt
  diff utils.R utils.txt
}

---
title: "An overview of pQTLdata"
output:
  bookdown::html_document2:
    toc: true
    toc_float: true
    number_sections: true
    self_contained: false
fontsize: 11pt
bibliography: '`r system.file("REFERENCES.bib", package="pQTLdata")`'
csl: nature-genetics.csl
pkgdown:
  as_is: true
vignette: >
  %\VignetteIndexEntry{pQTLdata}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r setup, include=FALSE}
set.seed(0)
knitr::opts_chunk$set(
  out.extra = 'style="display:block; margin: auto"',
  fig.align = "center",
  fig.path = "pQTLdata/",
  collapse = TRUE,
  comment = "#>",
  dev = "CairoPNG")
```

```{r, echo=FALSE, message=FALSE, warning=FALSE}
pkgs <- c("dplyr", "grid", "EnsDb.Hsapiens.v75", "ensembldb", "IRanges", "knitr", "org.Hs.eg.db", "S4Vectors", "VennDiagram")
for (p in pkgs) if (length(grep(paste("^package:", p, "$", sep=""), search())) == 0) {
    if (!requireNamespace(p)) warning(paste0("This vignette needs package `", p, "'; please install"))
}
invisible(suppressMessages(lapply(pkgs, require, character.only = TRUE)))
sys_options <- options(knitr.kable.NA=NULL)
new_options <- options(knitr.kable.NA='')
```

This package intends to gather information, metadata and relevant scripts in proteogenomic analysis.

# Collections

As used in several years of proteomic analysis and for future extensions, the collections are in two locations:

* **`data/`**. R datasets.
* **`inst/`**. `EndNote/`, `Olink/`, `scripts/`, `SomaLogic/`, which spread into the package's root directory after installation.

While `library(help=pQTLdata)` displays the general information, `? pQTLdata` can give a list of data objects in the package.

# Protein panels

## Caprion

As has been the norm, no snapshot upon data release was provided which consequently requires substantial effort and the notable ones are highlighted here.

```{r caprion, echo=FALSE}
options(new_options)
accession_list <- c("P04745", "Q9GZN8", "P0C0L5", "Q96N11", "P48960",
                    "Q9NUQ9", "P04062", "P69905", "P62805", "O14745",
                    "P23381", "P54577")
updated_list <- dplyr::filter(pQTLdata::caprion,Accession %in% accession_list) |>
                dplyr::ungroup() |>
                dplyr::select(Gene,Gene.orig,Protein,Accession,ensGenes,chr,start,end)
knitr::kable(updated_list,digits=2,caption="Updated information on Caprion")
options(sys_options)
```

which again is useful for extracting data from GTEx v8.

## Olink

This includes 12 qPCR panels, 15 Target 96 panels and Explore panels.

## SomaScan

Both `SomaScanV4.1` and the latest `SomaScan11k` are directly from SomaLogic.

## SWATH-MS

This panel has been used in an experimental data acquisition and analysis.

## Overlap of proteins

It is of interest to compare some of these,

```{r overlap1, echo=FALSE, fig.cap="Overlap of Olink Explore HT, SomaScan V4.1 and Caprion", fig.height=9, fig.width=9, messages=FALSE, results="hide"}
suppressMessages(library(dplyr))
suppressMessages(library(VennDiagram))
uniprot <- list(Olink=pull(pQTLdata::Olink_Explore_HT,UniProt.ID),
                SomaScan=pull(pQTLdata::SomaScanV4.1,UniProt.ID),
                Caprion=pull(pQTLdata::caprion,Accession))
lapply(uniprot,head)
olink_somascan_caprion <- VennDiagram::venn.diagram(uniprot,filename = NULL,disable.logging = TRUE,
                                                    cex = 2.5, cat.cex = 2.5, cat.pos = c(0,0,180),
                                                    height=8,width=8,units="in")
grid.newpage()
grid.draw(olink_somascan_caprion)
```

```{r overlap2, echo=FALSE, fig.cap="Overlap of Olink Explore HT, SomaScan 11K and Caprion", fig.height=9, fig.width=9, messages=FALSE, results="hide"}
suppressMessages(library(dplyr))
suppressMessages(library(VennDiagram))
uniprot <- list(Olink=pull(pQTLdata::Olink_Explore_HT,UniProt.ID),
                SomaScan=pull(pQTLdata::SomaScan11k,UniProt.ID),
                Caprion=pull(pQTLdata::caprion,Accession))
lapply(uniprot,head)
olink_somascan_caprion <- VennDiagram::venn.diagram(uniprot,filename = NULL,disable.logging = TRUE,
                                                    cex = 2.5, cat.cex = 2.5, cat.pos = c(0,0,180),
                                                    height=8,width=8,units="in")
grid.newpage()
grid.draw(olink_somascan_caprion)
```

# Published data

This associates with several panels, including SomaScan (`SomaScan160410`)@sun18, Olink qPCR inflammation
(`inf1`) @zhao23 and Seer (`seer1980`) @suhre24. In particular, `inf1` contains updates from the original release by Olink.

```{r inf1, echo=FALSE}
options(new_options)
knitr::kable(pQTLdata::inf1,digits=2,caption="Olink/inflammation panel")
options(sys_options)
```

# Reference data

We showcase `EnsDb.Hsapiens.v75` from Bioconductor.

```{r refdata, eval=requireNamespace("EnsDb.Hsapiens.v75", quietly=TRUE), warnings=FALSE}
options(new_options)
ensembldb::metadata(EnsDb.Hsapiens.v75)
ensembldb::keytypes(EnsDb.Hsapiens.v75)
exon_info <- ensembldb::exons(EnsDb.Hsapiens.v75)
gene_info <- ensembldb::genes(EnsDb.Hsapiens.v75)
transcript_info <- ensembldb::transcripts(EnsDb.Hsapiens.v75)
colnames(S4Vectors::mcols(gene_info))
colnames(S4Vectors::mcols(transcript_info))
overlaps <- IRanges::findOverlaps(transcript_info, gene_info)
overlapping_transcripts <- transcript_info[queryHits(overlaps)]
overlapping_genes <- gene_info[subjectHits(overlaps)]
overlap_data <- data.frame(
  transcript_id = mcols(overlapping_transcripts)$tx_id,
  gene_id = S4Vectors::mcols(overlapping_genes)$gene_id,
  gene_name = S4Vectors::mcols(overlapping_genes)$gene_name,
  start = pmax(start(overlapping_transcripts), start(overlapping_genes)),
  end = pmin(end(overlapping_transcripts), end(overlapping_genes))
)
gene_symbols <- c("BRCA1", "TP53")
gene_data <- subset(overlap_data,gene_name%in%gene_symbols,select=-c(gene_id,gene_name))
cols <- c("UNIPROTID","PROTEINID","GENEID","GENENAME","SEQNAME","TXID")
info <- ensembldb::select(EnsDb.Hsapiens.v75, keys = gene_symbols, 
                          columns = cols, keytype = "SYMBOL") |>
        dplyr::left_join(head(gene_data,15),by=c('TXID'='transcript_id')) |>
        subset(!is.na(UNIPROTID)&!is.na(start)&!is.na(end))
knitr::kable(head(info,15),caption="Annotation for BRCA1 and TP53")
keytypes(org.Hs.eg.db)
uniprot_ids <- ensembldb::select(org.Hs.eg.db, keys = gene_symbols, columns = "UNIPROT", keytype = "SYMBOL")
options(sys_options)
```

where `org.Hs.eg.db` is more focused on genes.

# Scripts

An analysis involving COVID-19 data is in `Olink/` directory, while the `scripts/` directory records data generation which potentially can be extended.
Specifically, `docs.sh` operates with GitHub while `cran.sh` builds, installs, and checks for compliance with the Comprehensive R Archive Network (CRAN).

# URLs

- CellCarta, <https://cellcarta.com/>
- EndNote, <https://endnote.com/>
- ENSEMBL BioMart, <https://www.ensembl.org/index.html>
- GitHub, <https://github.com/>
- NULISA, <https://alamarbio.com/technology/nulisa-platform/>
- NCI Proteomic Data Commons, <https://pdc.cancer.gov/pdc/browse>
- Olink, <https://olink.com/> (<https://olink.com/publications>)
- SCALLOP consortium, <http://www.scallop-consortium.com/>
- Seer, <https://seer.bio/>
- SomaLogic, <https://somalogic.com/>
- SWATH-MS, <https://www.creative-proteomics.com/ngpro/swath-ms.html>
- Thermo Fisher Scientific - LSMS, <https://github.com/thermofisherlsms>
- UCSC, <https://genome.ucsc.edu/>

# References {-}

The `EndNote/` directory includes references in @sun18 and @suhre20 formatted in EndNote.
